/*********************************************
 * OPL 6.3 Model
 * Author: Masahiko UMENO
 * Creation Date: 2010/06/21 at 15:00:00
 *********************************************/

using CP;


range r = 0..3;
string Names[r] = ["blue", "white", "yellow", "green"]; 

/*
range r = 0..2;
string Names[r] = ["blue", "white", "yellow"]; 
*/

dvar int Hokkaido in r;
dvar int Aomori in r;
dvar int Akita in r;
dvar int Iwate  in r;
dvar int Yamagata in r;
dvar int Miyagi in r;
dvar int Fukushima in r;
dvar int Niigata in r;
dvar int Gunma in r;
dvar int Tochigi  in r;
dvar int Ibaragi in r;
dvar int Chiba in r;
dvar int Tokyo in r;
dvar int Saitama in r;
dvar int Kanagawa in r;
dvar int Yamanashi  in r;
dvar int Shizuoka in r;
dvar int Nagano in r;
dvar int Gifu in r;
dvar int Toyama in r;
dvar int Ishikawa in r;
dvar int Fukui  in r;
dvar int Aichi in r;
dvar int Shiga in r;
dvar int Mie in r;
dvar int Nara in r;
dvar int Wakayama in r;
dvar int Kyoto in r;
dvar int Osaka  in r;
dvar int Hyogo in r;
dvar int Shimane in r;
dvar int Tottori in r;
dvar int Okayama in r;
dvar int Hiroshima in r;
dvar int Yamaguchi  in r;
dvar int Kagawa in r;
dvar int Ehime in r;
dvar int Tokushima in r;
dvar int Kochi in r;
dvar int Fukuoka in r;
dvar int Oita  in r;
dvar int Miyazaki in r;
dvar int Kagoshima in r;
dvar int Nagasaki in r;
dvar int Saga in r;
dvar int Kumamoto in r;
dvar int Okinawa  in r;


subject to {  
	Hokkaido != Aomori;
	Aomori != Iwate;
	Aomori != Akita;
	Iwate != Miyagi;
	Akita != Yamagata;
	Akita != Miyagi;
	Yamagata != Fukushima;
	Yamagata != Niigata;
	Niigata != Fukushima;
	Niigata != Gunma;
	Niigata != Nagano;
	Niigata != Toyama;
	Fukushima != Ibaragi;
	Fukushima != Tochigi;
	Fukushima != Gunma;
	Gunma != Saitama;
	Gunma != Nagano;
	Gunma != Tochigi;
	Tochigi != Ibaragi;
	Tochigi != Saitama;
	Ibaragi != Chiba;
	Ibaragi != Saitama;
	Saitama != Chiba;
	Saitama != Tokyo;
	Saitama != Yamanashi;
	Saitama != Nagano;
	Chiba != Tokyo;
	Chiba != Kanagawa;
	Tokyo != Yamanashi;
	Tokyo != Kanagawa;
	Kanagawa != Yamanashi;
	Kanagawa != Shizuoka;
	Yamanashi != Nagano;
	Yamanashi != Shizuoka;
	Shizuoka != Nagano;
	Shizuoka != Aichi;
	Nagano != Aichi;
	Nagano != Gifu;
	Nagano != Toyama;
	Toyama != Ishikawa;
	Toyama != Gifu;
	Ishikawa != Fukui;
	Ishikawa != Gifu;
	Fukui != Kyoto;
	Fukui != Shiga;
	Fukui != Gifu;
	Gifu != Aichi;
	Gifu != Mie;
	Gifu != Shiga;
	Aichi != Mie;
	Mie != Shiga;
	Mie != Kyoto;
	Mie != Nara;
	Mie != Wakayama;
	Shiga != Kyoto;
	Kyoto != Osaka;
	Kyoto != Hyogo;
	Kyoto != Nara;
	Nara != Osaka;
	Nara != Wakayama;
	Wakayama != Osaka;
	Wakayama != Hyogo;
	Wakayama != Tokushima;
	Osaka != Hyogo;
	Hyogo != Tottori;
	Hyogo != Okayama;
	Hyogo != Kagawa;
	Hyogo != Tokushima;
	Hyogo != Wakayama;
	Tottori != Shimane;
	Tottori != Okayama;
	Tottori != Hiroshima;
	Shimane != Hiroshima;
	Shimane != Yamaguchi;
	Okayama != Hiroshima;
	Okayama != Kagawa;
	Hiroshima != Yamaguchi;
	Hiroshima != Ehime;
	Hiroshima != Kagawa;
	Kagawa != Tokushima;
	Kagawa != Ehime;
	Tokushima != Ehime;
	Tokushima != Kochi;
	Kochi != Ehime;
	Ehime != Yamaguchi;
	Ehime != Oita;
	Yamaguchi != Fukuoka;
	Fukuoka != Saga;
	Fukuoka != Kumamoto;
	Fukuoka != Oita;
	Fukuoka != Nagasaki;
	Saga != Nagasaki;
	Nagasaki != Kumamoto;
	Kumamoto != Oita;
	Kumamoto != Miyazaki;
	Kumamoto != Kagoshima;
	Oita != Miyazaki;
	Miyazaki != Kagoshima;
	Kagoshima != Okinawa;
	 
	
	  
}

execute {
	writeln("Hokkaido:",Names[Hokkaido]);
	writeln("Aomori:",Names[Aomori]);
	writeln("Akita:",Names[Akita]);
	writeln("Iwate:",Names[Iwate]);
	writeln("Yamagata:",Names[Yamagata]);
	writeln("Miyagi:",Names[Miyagi]);
	writeln("Fukushima:",Names[Fukushima]);
	writeln("Niigata:",Names[Niigata]);
	writeln("Gunma:",Names[Gunma]);
	writeln("Tochigi:",Names[Tochigi]);
	writeln("Ibaragi:",Names[Ibaragi]);
	writeln("Chiba:",Names[Chiba]);
	writeln("Tokyo:",Names[Tokyo]);
	writeln("Saitama:",Names[Saitama]);
	writeln("Kanagawa:",Names[Kanagawa]);
	writeln("Yamanashi:",Names[Yamanashi]);
	writeln("Shizuoka:",Names[Shizuoka]);
	writeln("Nagano:",Names[Nagano]);
	writeln("Gifu:",Names[Gifu]);
	writeln("Toyama:",Names[Toyama]);
	writeln("Ishikawa:",Names[Ishikawa]);
	writeln("Fukui:",Names[Fukui]);
	writeln("Aichi:",Names[Aichi]);
	writeln("Shiga:",Names[Shiga]);
	writeln("Mie:",Names[Mie]);
	writeln("Nara:",Names[Nara]);
	writeln("Wakayama:",Names[Wakayama]);
	writeln("Kyoto:",Names[Kyoto]);
	writeln("Osaka:",Names[Osaka]);
	writeln("Hyogo:",Names[Hyogo]);
	writeln("Shimane:",Names[Shimane]);
	writeln("Tottori:",Names[Tottori]);
	writeln("Okayama:",Names[Okayama]);
	writeln("Hiroshima:",Names[Hiroshima]);
	writeln("Yamaguchi:",Names[Yamaguchi]);
	writeln("Kagawa:",Names[Kagawa]);
	writeln("Ehime:",Names[Ehime]);
	writeln("Tokushima:",Names[Tokushima]);
	writeln("Kochi:",Names[Kochi]);
	writeln("Fukuoka:",Names[Fukuoka]);
	writeln("Oita:",Names[Oita]);
	writeln("Miyazaki:",Names[Miyazaki]);
	writeln("Kagoshima:",Names[Kagoshima]);
	writeln("Nagasaki:",Names[Nagasaki]);
	writeln("Saga:",Names[Saga]);
	writeln("Kumamoto:",Names[Kumamoto]);
	writeln("Okinawa:",Names[Okinawa]);
}
 